SystemOrganization addCategory: #'RTVoronyjBuilder-RT'!

RTAbstractElementShape subclass: #RTPolygon
	instanceVariableNames: 'vertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder-RT'!

!RTPolygon commentStamp: 'NataliaTymchuk 7/5/2014 19:45' prior: 0!
I am a shape which builds the polygon sequentialy conecting my vertices.

For example:
RTPolygon new 
	vertices:{
		25 @ 00 .
		10 @ 50 .
		50 @ 20 .
		00 @ 20 .
		40 @ 50 }.!

!RTPolygon methodsFor: 'hooks' stamp: 'NataliaTymchuk 6/15/2014 19:08'!
trachelShapeClass
	^ TRPolygonShape
! !

!RTPolygon methodsFor: 'hooks' stamp: 'NataliaTymchuk 6/23/2014 19:12'!
updateFor: anElement trachelShape: trachelShape

	trachelShape isNil ifTrue: [ ^ self ].
	trachelShape color: (self colorFor: anElement).
	trachelShape vertices: vertices! !

!RTPolygon methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/15/2014 19:09'!
vertices
	^ vertices! !

!RTPolygon methodsFor: 'accessing' stamp: 'NataliaTymchuk 6/15/2014 19:09'!
vertices: anObject
	vertices := anObject! !

TRShape subclass: #TRPolygonShape
	instanceVariableNames: 'vertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTVoronyjBuilder-RT'!

!TRPolygonShape commentStamp: 'NataliaTymchuk 7/5/2014 19:47' prior: 0!
I am shape which builds closed path following ordered collection of vertices.
!

!TRPolygonShape methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/15/2014 19:18'!
computePath
	canvas ifNil: [ ^ self ].
	path := self athensCanvas
		createPath: [ :builder | 
			builder
				absolute;
				moveTo: vertices last.
			vertices do: [ :v |
				builder lineTo: v ].
			builder closePath ]! !

!TRPolygonShape methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/15/2014 19:15'!
encompassingRectangle
	^ vertices min corner: vertices max! !

!TRPolygonShape methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 8/8/2014 14:47'!
height
^ self encompassingRectangle height ! !

!TRPolygonShape methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 8/8/2014 14:45'!
includesPoint: point

  ^self encompassingRectangle containsPoint: point! !

!TRPolygonShape methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 8/8/2014 15:25'!
translateBy: aPoint
	vertices := vertices collect:[ :each | each + aPoint].
	self triggerCallbacksForStep: aPoint.
	self computePath! !

!TRPolygonShape methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 8/8/2014 15:20'!
translateTo: aPoint
| dist |
	dist := aPoint - self encompassingRectangle center.
	self translateBy: dist.! !

!TRPolygonShape methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/15/2014 19:13'!
vertices: aCollection 
	vertices := aCollection! !

!TRPolygonShape methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 8/8/2014 14:47'!
width
^ self encompassingRectangle width! !
